import uiRouter, {StateProvider} from "@uirouter/angularjs";
import * as angular from "angular";
import {NotificationModule} from "../shared/notification/notification.module";
import {UserModule} from "../shared/user/user.module";
import {AdminLayoutComponent} from "./admin-layout.component";
import {AdminDashboardPageComponent} from "./dashboard-page/dashboard-page.component";
import {ManageUsersPageComponent} from "./manage-users-page/manage-users-page.component";
import {AdminNavbar} from "./navbar/navbar.component";

export const AdminModule = angular
    .module("admin", [uiRouter, NotificationModule, UserModule])
    .component("adminLayout", AdminLayoutComponent)
    .component("adminNavbar", AdminNavbar)
    .component("adminDashboardPage", AdminDashboardPageComponent)
    .component("manageUsersPage", ManageUsersPageComponent)

    .config(($stateProvider: StateProvider) => {
        $stateProvider
            .state("admin", {
                url: "/admin",
                abstract: true,
                component: "adminLayout",
            })
            .state("admin.dashboard", {
                url: "",
                views: {
                    content: {
                        component: "adminDashboardPage"
                    }
                }
            })
            .state("admin.users", {
                url: "/users",
                views: {
                    content: {
                        component: "manageUsersPage"
                    }
                }
            });
    })
    .name;
