import {IComponentOptions} from "angular";
import "ui-select/dist/select.css";

export interface IConfirmOpts {
    body: string;
    title?: string;
    noText?: string;
    yesText?: string;
}

class ConfirmModalController {

    private resolve: {options: IConfirmOpts};
    private options: IConfirmOpts;

    public $onInit() {
        this.options = this.resolve.options;
        this.options.title = this.options.title || "Are you sure?";
        this.options.noText = this.options.noText || "No";
        this.options.yesText = this.options.yesText || "Yes";
    }
}

export const ConfirmModalComponent: IComponentOptions = {
    controller: ConfirmModalController,
    template: require("./confirm-modal.html"),
    bindings: {
        close: "&",
        dismiss: "&",
        resolve: "<"
    }
};

