import {IComponentOptions, ILogService} from "angular";
import {values} from "lodash";
import {IUser} from "../user.model";
import "./user-list.less";

interface UserListItem extends IUser {
    selected: boolean;
}

class UserListController {

    private users: UserListItem[] = [];
    private loading = false;

    /* @ngInject */
    constructor(private $log: ILogService) {
        $log.info("UserListController");
    }

    public selectedUsers(): UserListItem[] {
        return this.users.filter((user) => user.selected);
    }

    public hasSelectedUsers(): boolean {
        return this.selectedUsers().length > 0;
    }
}

export const UserListComponent: IComponentOptions = {
    controller: UserListController,
    template: require("./user-list.html"),
    bindings: {
        users: "<",
        loading: "<",
        onDelete: "<"
    }
};
